diff --git a/oflog/libsrc/appender.cc b/oflog/libsrc/appender.cc
index 1bab778..524bc7c 100644
--- a/oflog/libsrc/appender.cc
+++ b/oflog/libsrc/appender.cc
@@ -4,7 +4,7 @@
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2003-2009 Tad E. Smith
+// Copyright 2003-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -20,37 +20,55 @@
 
 #include "dcmtk/oflog/appender.h"
 #include "dcmtk/oflog/layout.h"
+#include "dcmtk/oflog/logmacro.h"
 #include "dcmtk/oflog/helpers/loglog.h"
 #include "dcmtk/oflog/helpers/pointer.h"
 #include "dcmtk/oflog/helpers/strhelp.h"
+#include "dcmtk/oflog/helpers/property.h"
 #include "dcmtk/oflog/spi/factory.h"
 #include "dcmtk/oflog/spi/logevent.h"
+#include "dcmtk/oflog/internal/internal.h"
+#include "dcmtk/oflog/thread/syncpub.h"
+#include <stdexcept>
 
-using namespace dcmtk::log4cplus;
-using namespace dcmtk::log4cplus::helpers;
-using namespace dcmtk::log4cplus::spi;
 
+namespace dcmtk
+{
+namespace log4cplus
+{
 
 
 ///////////////////////////////////////////////////////////////////////////////
-// dcmtk::log4cplus::ErrorHandler dtor
+// log4cplus::ErrorHandler dtor
 ///////////////////////////////////////////////////////////////////////////////
 
+ErrorHandler::ErrorHandler ()
+{ }
+
+
 ErrorHandler::~ErrorHandler()
-{
-}
+{ }
 
 
 
 ///////////////////////////////////////////////////////////////////////////////
-// dcmtk::log4cplus::OnlyOnceErrorHandler public methods
+// log4cplus::OnlyOnceErrorHandler 
 ///////////////////////////////////////////////////////////////////////////////
 
+OnlyOnceErrorHandler::OnlyOnceErrorHandler()
+    : firstTime(true)
+{ }
+
+
+OnlyOnceErrorHandler::~OnlyOnceErrorHandler ()
+{ }
+
+
 void
-OnlyOnceErrorHandler::error(const tstring& err)
+OnlyOnceErrorHandler::error(const log4cplus::tstring& err)
 {
     if(firstTime) {
-        getLogLog().error(err);
+        helpers::getLogLog().error(err);
         firstTime = false;
     }
 }
@@ -66,52 +84,64 @@ OnlyOnceErrorHandler::reset()
 
 
 ///////////////////////////////////////////////////////////////////////////////
-// dcmtk::log4cplus::Appender ctors
+// log4cplus::Appender ctors
 ///////////////////////////////////////////////////////////////////////////////
 
 Appender::Appender()
  : layout(new SimpleLayout()),
    name( DCMTK_LOG4CPLUS_TEXT("") ),
    threshold(NOT_SET_LOG_LEVEL),
-   errorHandler(new OnlyOnceErrorHandler()),
+   filter(),
+   errorHandler(new OnlyOnceErrorHandler),
+   lockFile(),
+   useLockFile(false),
    closed(false)
 {
 }
 
 
 
-Appender::Appender(const helpers::Properties properties)
- : layout(new SimpleLayout()),
-   name( DCMTK_LOG4CPLUS_TEXT("") ),
-   threshold(NOT_SET_LOG_LEVEL),
-   errorHandler(new OnlyOnceErrorHandler()),
-   closed(false)
+Appender::Appender(const log4cplus::helpers::Properties & properties)
+    : layout(new SimpleLayout())
+    , name()
+    , threshold(NOT_SET_LOG_LEVEL)
+    , filter()
+    , errorHandler(new OnlyOnceErrorHandler)
+    , lockFile()
+    , useLockFile(false)
+    , closed(false)
 {
-    if(properties.exists( DCMTK_LOG4CPLUS_TEXT("layout") )) {
-        tstring factoryName = properties.getProperty( DCMTK_LOG4CPLUS_TEXT("layout") );
-        LayoutFactory* factory = getLayoutFactoryRegistry().get(factoryName);
+    if(properties.exists( DCMTK_LOG4CPLUS_TEXT("layout") ))
+    {
+        log4cplus::tstring const & factoryName
+            = properties.getProperty( DCMTK_LOG4CPLUS_TEXT("layout") );
+        spi::LayoutFactory* factory
+            = spi::getLayoutFactoryRegistry().get(factoryName);
         if(factory == 0) {
-            getLogLog().error(  DCMTK_LOG4CPLUS_TEXT("Cannot find LayoutFactory: \"")
-                              + factoryName
-                              + DCMTK_LOG4CPLUS_TEXT("\"") );
+            helpers::getLogLog().error(
+                DCMTK_LOG4CPLUS_TEXT("Cannot find LayoutFactory: \"")
+                + factoryName
+                + DCMTK_LOG4CPLUS_TEXT("\"") );
             return;
         }
 
-        Properties layoutProperties =
+        helpers::Properties layoutProperties =
                 properties.getPropertySubset( DCMTK_LOG4CPLUS_TEXT("layout.") );
         try {
-            tstring error;
-            OFauto_ptr<Layout> newLayout(factory->createObject(layoutProperties, error));
+            OFauto_ptr<Layout> newLayout(factory->createObject(layoutProperties));
             if(newLayout.get() == 0) {
-                getLogLog().error(  DCMTK_LOG4CPLUS_TEXT("Failed to create appender: ")
-                                  + factoryName + " " + error);
+                helpers::getLogLog().error(
+                    DCMTK_LOG4CPLUS_TEXT("Failed to create appender: ")
+                    + factoryName);
             }
             else {
                 layout = newLayout;
             }
         }
-        catch(...) {
-            getLogLog().error(  DCMTK_LOG4CPLUS_TEXT("Exception caught while creating Layout"));
+        catch(STD_NAMESPACE exception const & e) {
+            helpers::getLogLog().error( 
+                DCMTK_LOG4CPLUS_TEXT("Error while creating Layout: ")
+                + DCMTK_LOG4CPLUS_C_STR_TO_TSTRING(e.what()));
             return;
         }
 
@@ -120,39 +150,66 @@ Appender::Appender(const helpers::Properties properties)
     // Support for appender.Threshold in properties configuration file
     if(properties.exists(DCMTK_LOG4CPLUS_TEXT("Threshold"))) {
         tstring tmp = properties.getProperty(DCMTK_LOG4CPLUS_TEXT("Threshold"));
-        tmp = toUpper(tmp);
-        threshold = getLogLevelManager().fromString(tmp);
+        tmp = log4cplus::helpers::toUpper(tmp);
+        threshold = log4cplus::getLogLevelManager().fromString(tmp);
     }
 
     // Configure the filters
-    Properties filterProps = properties.getPropertySubset( DCMTK_LOG4CPLUS_TEXT("filters.") );
-    int filterCount = 0;
-    FilterPtr filterChain;
-    tstring filterName, factoryName;
-    while( filterProps.exists(filterName = convertIntegerToString(++filterCount)) ) {
-        factoryName = filterProps.getProperty(filterName);
-        FilterFactory* factory = getFilterFactoryRegistry().get(factoryName);
-
-        if(factory == 0) {
+    helpers::Properties filterProps
+        = properties.getPropertySubset( DCMTK_LOG4CPLUS_TEXT("filters.") );
+    unsigned filterCount = 0;
+    spi::FilterPtr filterChain;
+    tstring filterName;
+    while (filterProps.exists(
+        filterName = helpers::convertIntegerToString (++filterCount)))
+    {
+        tstring const & factoryName = filterProps.getProperty(filterName);
+        spi::FilterFactory* factory
+            = spi::getFilterFactoryRegistry().get(factoryName);
+
+        if(! factory)
+        {
             tstring err = DCMTK_LOG4CPLUS_TEXT("Appender::ctor()- Cannot find FilterFactory: ");
-            getLogLog().error(err + factoryName);
+            helpers::getLogLog().error(err + factoryName);
             continue;
         }
-        tstring error;
-        FilterPtr tmp_filter = factory->createObject
-                      (filterProps.getPropertySubset(filterName + DCMTK_LOG4CPLUS_TEXT(".")), error);
-        if(tmp_filter.get() == 0) {
+        spi::FilterPtr tmpFilter = factory->createObject (
+            filterProps.getPropertySubset(filterName + DCMTK_LOG4CPLUS_TEXT(".")));
+        if (! tmpFilter)
+        {
             tstring err = DCMTK_LOG4CPLUS_TEXT("Appender::ctor()- Failed to create filter: ");
-            getLogLog().error(err + filterName + " " + error);
+            helpers::getLogLog().error(err + filterName);
         }
-        if(filterChain.get() == 0) {
-            filterChain = tmp_filter;
+        if (! filterChain)
+            filterChain = tmpFilter;
+        else
+            filterChain->appendFilter(tmpFilter);
+    }
+    setFilter(filterChain);
+
+    properties.getBool (useLockFile, DCMTK_LOG4CPLUS_TEXT("UseLockFile"));
+    if (useLockFile)
+    {
+        tstring const & lockFileName
+            = properties.getProperty (DCMTK_LOG4CPLUS_TEXT ("LockFile"));
+        if (! lockFileName.empty ())
+        {
+            try
+            {
+                lockFile.reset (new helpers::LockFile (lockFileName));
+            }
+            catch (STD_NAMESPACE runtime_error const &)
+            {
+                return;
+            }
         }
-        else {
-            filterChain->appendFilter(tmp_filter);
+        else
+        {
+            helpers::getLogLog ().debug (
+                DCMTK_LOG4CPLUS_TEXT (
+                    "UseLockFile is true but LockFile is not specified"));
         }
     }
-    setFilter(filterChain);
 }
 
 
@@ -162,21 +219,20 @@ Appender::~Appender()
 
 
 ///////////////////////////////////////////////////////////////////////////////
-// dcmtk::log4cplus::Appender public methods
+// log4cplus::Appender public methods
 ///////////////////////////////////////////////////////////////////////////////
 
 void
 Appender::destructorImpl()
 {
-    getLogLog().debug(  DCMTK_LOG4CPLUS_TEXT("Destroying appender named [")
-                      + name
-                      + DCMTK_LOG4CPLUS_TEXT("]."));
+    helpers::getLogLog().debug(  DCMTK_LOG4CPLUS_TEXT("Destroying appender named [")
+        + name
+        + DCMTK_LOG4CPLUS_TEXT("]."));
 
     // An appender might be closed then destroyed. There is no
     // point in closing twice.
-    if(closed) {
+    if(closed)
         return;
-    }
 
     close();
     closed = true;
@@ -185,31 +241,62 @@ Appender::destructorImpl()
 
 
 void
-Appender::doAppend(const InternalLoggingEvent& event)
+Appender::doAppend(const log4cplus::spi::InternalLoggingEvent& event)
 {
-    DCMTK_LOG4CPLUS_BEGIN_SYNCHRONIZE_ON_MUTEX( access_mutex )
-        if(closed) {
-            getLogLog().error(  DCMTK_LOG4CPLUS_TEXT("Attempted to append to closed appender named [")
-                              + name
-                              + DCMTK_LOG4CPLUS_TEXT("]."));
-            return;
-        }
+    thread::MutexGuard guard (access_mutex);
 
-        if(!isAsSevereAsThreshold(event.getLogLevel())) {
-            return;
-        }
+    if(closed) {
+        helpers::getLogLog().error(
+            DCMTK_LOG4CPLUS_TEXT("Attempted to append to closed appender named [")
+            + name
+            + DCMTK_LOG4CPLUS_TEXT("]."));
+        return;
+    }
+
+    // Check appender's threshold logging level.
+
+    if (! isAsSevereAsThreshold(event.getLogLevel()))
+        return;
+
+    // Evaluate filters attached to this appender.
 
-        if(checkFilter(filter.get(), event) == DENY) {
+    if (spi::checkFilter(filter.get(), event) == spi::DENY)
+        return;
+
+    // Lock system wide lock.
+
+    helpers::LockFileGuard lfguard;
+    if (useLockFile && lockFile.get ())
+    {
+        try
+        {
+            lfguard.attach_and_lock (*lockFile);
+        }
+        catch (STD_NAMESPACE runtime_error const &)
+        {
             return;
         }
+    }
+
+    // Finally append given event.
 
-        append(event);
-    DCMTK_LOG4CPLUS_END_SYNCHRONIZE_ON_MUTEX;
+    append(event);
 }
 
 
+tstring &
+Appender::formatEvent (const spi::InternalLoggingEvent& event) const
+{
+    internal::appender_sratch_pad & appender_sp = internal::get_appender_sp ();
+    detail::clear_tostringstream (appender_sp.oss);
+    layout->formatAndAppend(appender_sp.oss, event);
+    //appender_sp.oss.str().swap (appender_sp.str);
+    appender_sp.str.assign(appender_sp.oss.str().c_str(), appender_sp.oss.str().length());
+    return appender_sp.str;
+}
+
 
-tstring
+log4cplus::tstring
 Appender::getName()
 {
     return name;
@@ -218,9 +305,9 @@ Appender::getName()
 
 
 void
-Appender::setName(const tstring& name_)
+Appender::setName(const log4cplus::tstring& n)
 {
-    this->name = name_;
+    this->name = n;
 }
 
 
@@ -235,15 +322,18 @@ Appender::getErrorHandler()
 void
 Appender::setErrorHandler(OFauto_ptr<ErrorHandler> eh)
 {
-    if(eh.get() == NULL) {
+    if (! eh.get())
+    {
         // We do not throw exception here since the cause is probably a
         // bad config file.
-        getLogLog().warn(DCMTK_LOG4CPLUS_TEXT("You have tried to set a null error-handler."));
+        helpers::getLogLog().warn(
+            DCMTK_LOG4CPLUS_TEXT("You have tried to set a null error-handler."));
         return;
     }
-    DCMTK_LOG4CPLUS_BEGIN_SYNCHRONIZE_ON_MUTEX( access_mutex )
-        this->errorHandler = eh;
-    DCMTK_LOG4CPLUS_END_SYNCHRONIZE_ON_MUTEX;
+
+    thread::MutexGuard guard (access_mutex);
+
+    this->errorHandler = eh;
 }
 
 
@@ -251,9 +341,9 @@ Appender::setErrorHandler(OFauto_ptr<ErrorHandler> eh)
 void
 Appender::setLayout(OFauto_ptr<Layout> lo)
 {
-    DCMTK_LOG4CPLUS_BEGIN_SYNCHRONIZE_ON_MUTEX( access_mutex )
-        this->layout = lo;
-    DCMTK_LOG4CPLUS_END_SYNCHRONIZE_ON_MUTEX;
+    thread::MutexGuard guard (access_mutex);
+
+    this->layout = lo;
 }
 
 
@@ -265,3 +355,5 @@ Appender::getLayout()
 }
 
 
+} // namespace log4cplus
+} // end namespace dcmtk
diff --git a/oflog/libsrc/asyncap.cc b/oflog/libsrc/asyncap.cc
new file mode 100644
index 0000000..d47cb09
--- /dev/null
+++ b/oflog/libsrc/asyncap.cc
@@ -0,0 +1,205 @@
+//  Copyright (C) 2009-2010, Vaclav Haisman. All rights reserved.
+//  
+//  Redistribution and use in source and binary forms, with or without modifica-
+//  tion, are permitted provided that the following conditions are met:
+//  
+//  1. Redistributions of  source code must  retain the above copyright  notice,
+//     this list of conditions and the following disclaimer.
+//  
+//  2. Redistributions in binary form must reproduce the above copyright notice,
+//     this list of conditions and the following disclaimer in the documentation
+//     and/or other materials provided with the distribution.
+//  
+//  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
+//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+//  FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
+//  APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
+//  INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
+//  DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
+//  OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
+//  ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
+//  (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
+//  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+#include "dcmtk/oflog/config.h"
+#ifndef DCMTK_LOG4CPLUS_SINGLE_THREADED
+
+#include "dcmtk/oflog/asyncap.h"
+#include "dcmtk/oflog/spi/factory.h"
+#include "dcmtk/oflog/helpers/loglog.h"
+#include "dcmtk/oflog/helpers/property.h"
+#include "dcmtk/oflog/thread/syncpub.h"
+
+
+namespace dcmtk
+{
+namespace log4cplus
+{
+
+
+namespace
+{
+
+
+class QueueThread
+    : public thread::AbstractThread
+{
+public:
+    QueueThread (AsyncAppenderPtr const &, thread::QueuePtr const &);
+
+    virtual void run();
+
+private:
+    AsyncAppenderPtr appenders;
+    thread::QueuePtr queue;
+};
+
+
+QueueThread::QueueThread (AsyncAppenderPtr const & aai,
+    thread::QueuePtr const & q)
+    : appenders (aai)
+    , queue (q)
+{ }
+
+
+void
+QueueThread::run()
+{
+    typedef log4cplus::thread::Queue::queue_storage_type ev_buf_type;
+    ev_buf_type ev_buf;
+
+    while (true)
+    {
+        unsigned flags = queue->get_events (&ev_buf);
+        if (flags & thread::Queue::EVENT)
+        {
+            ev_buf_type::const_iterator const ev_buf_end = ev_buf.end ();
+            for (ev_buf_type::const_iterator it = ev_buf.begin ();
+                it != ev_buf_end; ++it)
+                appenders->appendLoopOnAppenders (*it);
+        }
+
+        if (((thread::Queue::EXIT | thread::Queue::DRAIN
+                | thread::Queue::EVENT) & flags)
+            == (thread::Queue::EXIT | thread::Queue::DRAIN
+                | thread::Queue::EVENT))
+            continue;
+        else if (thread::Queue::EXIT & flags)
+            break;
+    }
+}
+
+
+} // namespace
+
+
+AsyncAppender::AsyncAppender (SharedAppenderPtr const & app,
+    unsigned queue_len)
+    : queue_thread()
+    , queue()
+{
+    addAppender (app);
+    init_queue_thread (queue_len);
+}
+
+
+AsyncAppender::AsyncAppender (helpers::Properties const & props)
+    : queue_thread()
+    , queue()
+{
+    tstring const & appender_name =
+        props.getProperty (DCMTK_LOG4CPLUS_TEXT ("Appender"));
+    if (appender_name.empty ())
+    {
+        getErrorHandler ()->error (
+            DCMTK_LOG4CPLUS_TEXT ("Unspecified appender for AsyncAppender."));
+        return;
+    }
+
+    spi::AppenderFactoryRegistry & appender_registry
+        = spi::getAppenderFactoryRegistry ();
+    spi::AppenderFactory * factory = appender_registry.get (appender_name);
+    if (! factory)
+    {
+        tstring const err (DCMTK_LOG4CPLUS_TEXT ("AsyncAppender::AsyncAppender()")
+            DCMTK_LOG4CPLUS_TEXT (" - Cannot find AppenderFactory: "));
+        helpers::getLogLog ().error (err + appender_name);
+        // Add at least null appender so that we do not crash unexpectedly
+        // elsewhere.
+        // XXX: What about throwing an exception instead?
+        factory = appender_registry.get (
+            DCMTK_LOG4CPLUS_TEXT ("log4cplus::NullAppender"));
+    }
+
+    helpers::Properties appender_props = props.getPropertySubset (
+        DCMTK_LOG4CPLUS_TEXT ("Appender."));
+    addAppender (factory->createObject (appender_props));
+
+    unsigned queue_len = 100;
+    props.getUInt (queue_len, DCMTK_LOG4CPLUS_TEXT ("QueueLimit"));
+
+    init_queue_thread (queue_len);
+}
+
+
+AsyncAppender::~AsyncAppender ()
+{
+    destructorImpl ();
+}
+
+
+void
+AsyncAppender::init_queue_thread (unsigned queue_len)
+{
+    queue = new thread::Queue (queue_len);
+    queue_thread = new QueueThread (AsyncAppenderPtr (this), queue);
+    queue_thread->start ();
+    helpers::getLogLog ().debug (DCMTK_LOG4CPLUS_TEXT("Queue thread started."));
+}
+
+
+void
+AsyncAppender::close ()
+{
+    unsigned ret = queue->signal_exit ();
+    if (ret & (thread::Queue::ERROR_BIT | thread::Queue::ERROR_AFTER))
+        getErrorHandler ()->error (
+            DCMTK_LOG4CPLUS_TEXT ("Error in AsyncAppender::close"));
+    queue_thread->join ();
+}
+
+
+void
+AsyncAppender::append (spi::InternalLoggingEvent const & ev)
+{
+    if (queue_thread && queue_thread->isRunning ())
+    {
+        unsigned ret = queue->put_event (ev);
+        if (ret & (thread::Queue::ERROR_BIT | thread::Queue::ERROR_AFTER))
+        {
+            getErrorHandler ()->error (
+                DCMTK_LOG4CPLUS_TEXT ("Error in AsyncAppender::append,")
+                DCMTK_LOG4CPLUS_TEXT (" event queue has been lost."));
+            // Exit the queue consumer thread without draining
+            // the events queue.
+            queue->signal_exit (false);
+            queue_thread->join ();
+            queue_thread = 0;
+            queue = 0;
+            appendLoopOnAppenders (ev);
+        }
+    }
+    else
+    {
+        // If the thread has died for any reason, fall back to synchronous
+        // operation.
+        appendLoopOnAppenders (ev);
+    }
+}
+
+
+} // namespace log4cplus
+} // end namespace dcmtk
+
+
+#endif // #ifndef DCMTK_LOG4CPLUS_SINGLE_THREADED
diff --git a/oflog/libsrc/clfsap.cc b/oflog/libsrc/clfsap.cc
new file mode 100644
index 0000000..b867928
--- /dev/null
+++ b/oflog/libsrc/clfsap.cc
@@ -0,0 +1,304 @@
+// Module:  Log4cplus
+// File:    clfsappender.cxx
+// Created: 5/2012
+// Author:  Vaclav Zeman
+//
+//
+//  Copyright (C) 2012, Vaclav Zeman. All rights reserved.
+//  
+//  Redistribution and use in source and binary forms, with or without modifica-
+//  tion, are permitted provided that the following conditions are met:
+//  
+//  1. Redistributions of  source code must  retain the above copyright  notice,
+//     this list of conditions and the following disclaimer.
+//  
+//  2. Redistributions in binary form must reproduce the above copyright notice,
+//     this list of conditions and the following disclaimer in the documentation
+//     and/or other materials provided with the distribution.
+//  
+//  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
+//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+//  FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
+//  APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
+//  INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
+//  DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
+//  OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
+//  ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
+//  (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
+//  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+#include "dcmtk/oflog/config.h"
+#include "dcmtk/oflog/helpers/loglog.h"
+#include "dcmtk/oflog/helpers/property.h"
+#include "dcmtk/oflog/clfsap.h"
+#include "dcmtk/oflog/spi/factory.h"
+#include <sstream>
+#include <iomanip>
+#include <cstring>
+#include "dcmtk/oflog/config/windowsh.h"
+#include <clfsw32.h>
+#include <clfsmgmtw32.h>
+
+
+// Forward Declarations
+namespace dcmtk
+{
+namespace log4cplus
+{
+
+const unsigned CLFS_APPENDER_INITIAL_LOG_SIZE = 512 * 1024;
+const ULONG CLFS_APPENDER_DEFAULT_BUFFER_SIZE = 1024 * 64;
+
+
+namespace
+{
+
+static
+void
+loglog_win32_error (tchar const * msg)
+{
+    DWORD err = GetLastError ();
+    tostringstream oss;
+    oss << DCMTK_LOG4CPLUS_TEXT ("CLFSAppender: ") << msg << DCMTK_LOG4CPLUS_TEXT(": ")
+        << err << DCMTK_LOG4CPLUS_TEXT (" / 0x")
+        << STD_NAMESPACE setw (8) << STD_NAMESPACE setfill (DCMTK_LOG4CPLUS_TEXT ('0')) << STD_NAMESPACE hex
+        << err;
+    helpers::getLogLog ().error(OFString(oss.str().c_str(), oss.str().length()));
+}
+
+}
+
+
+struct CLFSAppender::Data
+{
+    Data ()
+        : log_name ()
+        , log_handle (INVALID_HANDLE_VALUE)
+        , buffer (0)
+        , buffer_size (0)
+    { }
+
+    tstring log_name;
+    HANDLE log_handle;
+    void * buffer;
+    ULONG buffer_size;
+};
+
+
+CLFSAppender::CLFSAppender (tstring const & logname, unsigned long logsize,
+    unsigned long buffersize)
+    : Appender ()
+    , data (new Data)
+{
+    init (logname, logsize, buffersize);
+}
+
+
+CLFSAppender::CLFSAppender (helpers::Properties const & props)
+    : Appender (props)
+    , data (new Data)
+{
+    tstring logname = props.getProperty (DCMTK_LOG4CPLUS_TEXT ("LogName"));
+
+    unsigned long logsize = CLFS_APPENDER_INITIAL_LOG_SIZE;
+    props.getULong (logsize, DCMTK_LOG4CPLUS_TEXT ("LogSize"));
+
+    unsigned long buffersize = CLFS_APPENDER_DEFAULT_BUFFER_SIZE;
+    props.getULong (buffersize, DCMTK_LOG4CPLUS_TEXT ("BufferSize"));
+
+    init (logname, logsize, buffersize);
+}
+
+
+CLFSAppender::~CLFSAppender ()
+{
+    destructorImpl ();
+    delete data;
+}
+
+
+void
+CLFSAppender::init (tstring const & logname, unsigned long logsize,
+    unsigned long buffersize)
+{
+    data->log_name = logname;
+    data->buffer_size = buffersize;
+
+    if (data->log_name.empty ())
+        helpers::getLogLog ().error (
+            DCMTK_LOG4CPLUS_TEXT ("CLFSAppender: empty log name"), true);
+
+    CLFS_MGMT_POLICY log_policy;
+    memset (&log_policy, 0, sizeof (log_policy));
+    log_policy.Version = CLFS_MGMT_POLICY_VERSION;
+    log_policy.LengthInBytes = sizeof (log_policy);
+    log_policy.PolicyFlags = 0;
+
+    CLFS_INFORMATION log_info;
+    ULONG info_size = sizeof (log_info);
+    ULONGLONG desired_size;
+    ULONGLONG resulting_size;
+
+    data->log_handle = CreateLogFile (
+        helpers::towstring (data->log_name).c_str (), GENERIC_WRITE | GENERIC_READ,
+        FILE_SHARE_DELETE | FILE_SHARE_WRITE | FILE_SHARE_READ, 0,
+        OPEN_ALWAYS, FILE_ATTRIBUTE_ARCHIVE);
+
+    if (data->log_handle == INVALID_HANDLE_VALUE)
+    {
+        loglog_win32_error (DCMTK_LOG4CPLUS_TEXT ("CreateLogFile()"));
+        goto error;
+    }
+
+    if (! RegisterManageableLogClient (data->log_handle, 0))
+    {
+        loglog_win32_error (DCMTK_LOG4CPLUS_TEXT ("RegisterManageableLogClient()"));
+        goto error;
+    }
+
+
+    if (! GetLogFileInformation (data->log_handle, &log_info, &info_size))
+    {
+        loglog_win32_error (DCMTK_LOG4CPLUS_TEXT ("GetLogFileInformation()"));
+        goto error;
+    }
+
+    if (log_info.TotalContainers == 0)
+    {
+        log_policy.PolicyType = ClfsMgmtPolicyNewContainerSize;
+        log_policy.PolicyParameters.NewContainerSize.SizeInBytes = logsize;
+        if (! InstallLogPolicy (data->log_handle, &log_policy))
+        {
+            loglog_win32_error (
+                DCMTK_LOG4CPLUS_TEXT ("InstallLogPolicy(ClfsMgmtPolicyNewContainerSize)"));
+            goto error;
+        }
+    }
+
+    desired_size = 0;
+    resulting_size = 0;
+    if (! SetLogFileSizeWithPolicy (data->log_handle, &desired_size,
+        &resulting_size))
+    {
+        loglog_win32_error (DCMTK_LOG4CPLUS_TEXT ("SetLogFileSizeWithPolicy()"));
+        goto error;
+    }
+
+    log_policy.PolicyType = ClfsMgmtPolicyAutoGrow;
+    log_policy.PolicyParameters.AutoGrow.Enabled = true;
+    if (! InstallLogPolicy (data->log_handle, &log_policy))
+    {
+        loglog_win32_error (
+            DCMTK_LOG4CPLUS_TEXT ("InstallLogPolicy(ClfsMgmtPolicyAutoGrow)"));
+        goto error;
+    }
+
+    log_policy.PolicyType = ClfsMgmtPolicyGrowthRate;
+    log_policy.PolicyParameters.GrowthRate.AbsoluteGrowthInContainers = 0;
+    log_policy.PolicyParameters.GrowthRate.RelativeGrowthPercentage = 10;
+    if (! InstallLogPolicy (data->log_handle, &log_policy))
+    {
+        loglog_win32_error (
+            DCMTK_LOG4CPLUS_TEXT ("InstallLogPolicy(ClfsMgmtPolicyGrowthRate)"));
+        goto error;
+    }
+
+    // TODO: Get underlying media sector size using GetDiskFreeSpace().
+    // TODO: What are reasonable values for cMaxWriteBuffers
+    // and cMaxReadBuffers?
+    if (! CreateLogMarshallingArea (data->log_handle, 0, 0, 0,
+        data->buffer_size, 8, 1, &data->buffer))
+    {
+        loglog_win32_error (DCMTK_LOG4CPLUS_TEXT ("CreateLogMarshallingArea"));
+        goto error;
+    }
+
+    return;
+
+error:
+    if (data->log_handle != INVALID_HANDLE_VALUE)
+    {
+        CloseHandle (data->log_handle);
+        data->log_handle = INVALID_HANDLE_VALUE;
+    }
+
+    return;
+}
+
+
+void
+CLFSAppender::close ()
+{
+    if (data->log_handle != INVALID_HANDLE_VALUE)
+    {
+        CloseHandle (data->log_handle);
+        data->log_handle = INVALID_HANDLE_VALUE;
+    }
+}
+
+
+void
+CLFSAppender::append (spi::InternalLoggingEvent const & ev)
+{
+    if (data->log_handle == INVALID_HANDLE_VALUE)
+        return;
+
+    // TODO: Expose log4cplus' internal TLS to use here.
+    tostringstream oss;    
+    layout->formatAndAppend(oss, ev);
+
+    tstring str = OFString(oss.str().c_str(), oss.str().length());
+    //oss.str ().swap (str);
+    if ((str.size () + 1) * sizeof (tchar) > data->buffer_size)
+        str.resize (data->buffer_size / sizeof (tchar));
+
+    CLFS_WRITE_ENTRY clfs_write_entry;
+    clfs_write_entry.Buffer = OFconst_cast(tchar *, str.c_str ());
+    clfs_write_entry.ByteLength
+        = OFstatic_cast(ULONG, (str.size () + 1) * sizeof (tchar));
+
+    if (! ReserveAndAppendLog (data->buffer, &clfs_write_entry, 1, 0, 0, 0, 0,
+        CLFS_FLAG_FORCE_APPEND, 0, 0))
+        loglog_win32_error (DCMTK_LOG4CPLUS_TEXT ("ReserveAndAppendLog"));
+}
+
+
+void
+CLFSAppender::registerAppender ()
+{
+    dcmtk::log4cplus::spi::AppenderFactoryRegistry & reg
+        = dcmtk::log4cplus::spi::getAppenderFactoryRegistry ();
+    DCMTK_LOG4CPLUS_REG_APPENDER (reg, CLFSAppender);
+}
+
+
+} // namespace log4cplus
+} // end namespace dcmtk
+
+
+extern "C"
+BOOL WINAPI DllMain(DCMTK_LOG4CPLUS_DLLMAIN_HINSTANCE,  // handle to DLL module
+                    DWORD fdwReason,     // reason for calling function
+                    LPVOID)  // reserved
+{
+    // Perform actions based on the reason for calling.
+    switch( fdwReason ) 
+    { 
+    case DLL_PROCESS_ATTACH:
+    {
+        dcmtk::log4cplus::CLFSAppender::registerAppender ();
+        break;
+    }
+
+    case DLL_THREAD_ATTACH:
+        break;
+
+    case DLL_THREAD_DETACH:
+        break;
+
+    case DLL_PROCESS_DETACH:
+        break;
+    }
+
+    return TRUE;  // Successful DLL_PROCESS_ATTACH.
+}
